# hkqr_fps

Encode structural FPS information to a QR code string or
Decode a QR code String to structural FPS information based on 
the [specification](https://fps.hkicl.com.hk/eng/fps/merchants/qr_code.php).

## Getting Started

### Encode

```dart
final qrString = HKQrInfo(
      isDynamic: true,
      fpsProxy: FpsProxy(FpsType.fpsId, '123456'),
      amount: '0.01',
    ).encode();
```

### Decode
```dart
final hkqrInfo = HKQrInfo.decode('000201010211...');
```

#### Decode tips
* Fail-fast: Decode will fail when first error was found.
* Warnings: Decode may success with some warnings, i.e. some unrecognized field found during decode.
* Mandatory: Mandatory fields must present even if not used in FPS.
* Optional: Optional fields must have valid format and length if present.

### example
There are 3 use cases in example
* Fill form of FPS information, encode it to a QR code string, and use [qr_flutter](https://github.com/theyakka/qr.flutter) to generate a QR image;
* Decode a QR code string to FPS information;
* Use [qr_code_scanner](https://github.com/juliuscanute/qr_code_scanner) to scan a QR image and decode scan result to FPS information.
